package ipcheck

import (
	"errors"
	"gitea.drugeyes.vip/pharnexbase/ipcheck/utils"
	"strings"
)

//SingleIpInRange 单个ip地址(范围)判断是否在配置ip范围内
func SingleIpInRange(ip, ipConfigStr string) (bool, error) {
	singleIp := utils.NewIpRange(ip)
	if singleIp == nil {
		return false, errors.New("ip格式错误！")
	}

	//判断ip范围是否满足从小到大的规则
	if err := singleIp.CheckIpRange(); err != nil {
		return false, err
	}

	ipConfigArr := strings.Split(strings.ReplaceAll(ipConfigStr, "\r\n", "\n"), "\n")
	for _, ipConfig := range ipConfigArr {
		containIp := utils.NewIpRange(ipConfig)
		if containIp != nil && singleIp.Type() == containIp.Type() { //只有ip类型相同才判断范围
			if containIp.IsContain(singleIp) == true {
				return true, nil
			}
		}
	}

	return false, nil
}
